
#include "stdafx.h"
#include "video.h"
#include "ConstantRateCtl.h"

#define WM_THREADFIREEVENT WM_USER+101

#define ERRORNR_CSTRATE_CONNECT 1401
#define ERRORSTR_CSTRATE_CONNECT "Unable to Connect"
#define ERRORNR_CSTRATE_BIND 1402
#define ERRORSTR_CSTRATE_BIND "Unable to Bind"
#define ERRORNR_CSTRATE_STARTSEND 1403
#define ERRORSTR_CSTRATE_STARTSEND "Unable to Start Sending"
#define ERRORNR_CSTRATE_STARTRECEIVE 1404
#define ERRORSTR_CSTRATE_STARTRECEIVE "Unable to Start Receiving"
#define ERRORNR_CSTRATE_BOTH 1405
#define ERRORSTR_CSTRATE_BOTH "Sending and Receiving not possible"


BEGIN_MESSAGE_MAP(CConstantRateWindow, CWnd)
	ON_MESSAGE(WM_THREADFIREEVENT,OnFireEventForThread)
END_MESSAGE_MAP()

HWND CConstantRateWindow::Create()
{
	LPCTSTR classname=AfxRegisterWndClass(0);
	CWnd::CreateEx(NULL,classname,NULL,NULL,1,1,1,1,NULL,NULL); ASSERT(m_hWnd!=NULL);
	return m_hWnd;
}

LRESULT CConstantRateWindow::OnFireEventForThread(WPARAM wParam, LPARAM lParam)
{
	m_pControl->FireReceive((long)m_pControl->tmp_adr, m_pControl->tmp_size);
	return TRUE;
}

IMPLEMENT_DYNCREATE(CConstantRateCtrl, COleControl)

BEGIN_MESSAGE_MAP(CConstantRateCtrl, COleControl)
	//{{AFX_MSG_MAP(CConstantRateCtrl)
	//}}AFX_MSG_MAP
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CConstantRateCtrl, COleControl)
	//{{AFX_DISPATCH_MAP(CConstantRateCtrl)
	DISP_PROPERTY_NOTIFY(CConstantRateCtrl, "BufferSize", m_bufferSize, OnBufferSizeChanged, VT_I4)
	DISP_PROPERTY_NOTIFY(CConstantRateCtrl, "DataRate", m_dataRate, OnDataRateChanged, VT_I4)
	DISP_PROPERTY_NOTIFY(CConstantRateCtrl, "BlockSize", m_blockSize, OnBlockSizeChanged, VT_I4)
	DISP_PROPERTY_NOTIFY(CConstantRateCtrl, "Sending", m_sending, OnSendingChanged, VT_BOOL)
	DISP_PROPERTY_NOTIFY(CConstantRateCtrl, "Host", m_Host, OnHostChanged, VT_BSTR)
	DISP_PROPERTY_NOTIFY(CConstantRateCtrl, "Port", m_Port, OnPortChanged, VT_I2)
	DISP_PROPERTY_NOTIFY(CConstantRateCtrl, "Receiving", m_receiving, OnReceivingChanged, VT_BOOL)
	DISP_PROPERTY_NOTIFY(CConstantRateCtrl, "Type", m_type, OnTypeChanged, VT_I2)
	DISP_PROPERTY_EX(CConstantRateCtrl, "BufferFilled", GetBufferFilled, SetNotSupported, VT_I2)
	DISP_PROPERTY_EX(CConstantRateCtrl, "PeerName", GetPeerName, SetNotSupported, VT_BSTR)
	DISP_FUNCTION(CConstantRateCtrl, "Send", Send, VT_BOOL, VTS_I4 VTS_I4)
	DISP_FUNCTION(CConstantRateCtrl, "Taken", Taken, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CConstantRateCtrl, "Data1", Data1, VT_I4, VTS_NONE)
	DISP_FUNCTION(CConstantRateCtrl, "Data2", Data2, VT_I4, VTS_NONE)
	DISP_FUNCTION(CConstantRateCtrl, "Size1", Size1, VT_I4, VTS_NONE)
	DISP_FUNCTION(CConstantRateCtrl, "Size2", Size2, VT_I4, VTS_NONE)
	DISP_FUNCTION(CConstantRateCtrl, "MessageBox", MessageBox, VT_EMPTY, VTS_BSTR VTS_I2 VTS_BSTR)
	DISP_FUNCTION(CConstantRateCtrl, "ClearBuffer", ClearBuffer, VT_EMPTY, VTS_NONE)
	//}}AFX_DISPATCH_MAP
	DISP_FUNCTION_ID(CConstantRateCtrl, "AboutBox", DISPID_ABOUTBOX, AboutBox, VT_EMPTY, VTS_NONE)
END_DISPATCH_MAP()

BEGIN_EVENT_MAP(CConstantRateCtrl, COleControl)
	//{{AFX_EVENT_MAP(CConstantRateCtrl)
	EVENT_CUSTOM("Receive", FireReceive, VTS_I4  VTS_I4)
	EVENT_CUSTOM("Overflow", FireOverflow, VTS_NONE)
	EVENT_CUSTOM("Disconnect", FireDisconnect, VTS_NONE)
	//}}AFX_EVENT_MAP
END_EVENT_MAP()

IMPLEMENT_OLECREATE_EX(CConstantRateCtrl, "VIDEO.ConstantRateCtrl.1", 0x96872faf, 0xd44c, 0x11d1, 0xa8, 0x98, 0, 0x20, 0xaf, 0xf8, 0x4c, 0xb3)
IMPLEMENT_OLETYPELIB(CConstantRateCtrl, _tlid, _wVerMajor, _wVerMinor)
const IID BASED_CODE IID_DConstantRate = { 0x96872fad, 0xd44c, 0x11d1, { 0xa8, 0x98, 0, 0x20, 0xaf, 0xf8, 0x4c, 0xb3 } };
const IID BASED_CODE IID_DConstantRateEvents = { 0x96872fae, 0xd44c, 0x11d1, { 0xa8, 0x98, 0, 0x20, 0xaf, 0xf8, 0x4c, 0xb3 } };
static const DWORD BASED_CODE _dwConstantRateOleMisc = OLEMISC_INVISIBLEATRUNTIME | OLEMISC_SETCLIENTSITEFIRST | OLEMISC_INSIDEOUT | OLEMISC_CANTLINKINSIDE | OLEMISC_RECOMPOSEONRESIZE;
IMPLEMENT_OLECTLTYPE(CConstantRateCtrl, IDS_CONSTANTRATE, _dwConstantRateOleMisc)

BOOL CConstantRateCtrl::CConstantRateCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	if (bRegister)
		return AfxOleRegisterControlClass(AfxGetInstanceHandle(), m_clsid, m_lpszProgID, IDS_CONSTANTRATE, IDB_CONSTANTRATE, afxRegApartmentThreading, _dwConstantRateOleMisc, _tlid, _wVerMajor, _wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}

CConstantRateCtrl::CConstantRateCtrl()
{
   initflag=0;
	InitializeIIDs(&IID_DConstantRate, &IID_DConstantRateEvents);
	m_sending=0;
	m_receiving=0;
	OnResetState();
   SetTransferBuffer(&puffer);
   hwndTarget=0;
   status=0;
   peername=0;
}

CConstantRateCtrl::~CConstantRateCtrl()
{
   OnResetState();
}

void CConstantRateCtrl::OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
   DrawOcxBitmap(this, pdc, rcBounds, IDB_CONSTANTRATE);
}

void CConstantRateCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);

   PX_Bool(pPX, "Sending", m_sending, FALSE);
   PX_Long(pPX, "BufferSize", m_bufferSize, 500000);
   PX_Long(pPX, "DataRate", m_dataRate, 300000);
   PX_Long(pPX, "BlockSize", m_blockSize, 8*1024);
   PX_String(pPX, "Host", m_Host, "localhost");
   PX_Short(pPX, "Port", m_Port, 2000);
   PX_Short(pPX, "Type", m_type, 0);
}

void CConstantRateCtrl::OnResetState()
{
	COleControl::OnResetState();  // Resets defaults found in DoPropExchange
	if (m_receiving) { m_receiving=FALSE; OnReceivingChanged(); }
	if (m_sending) { m_sending=FALSE; OnSendingChanged(); }
}

void CConstantRateCtrl::AboutBox()
{
	CDialog dlgAbout(IDD_ABOUTBOX);
	dlgAbout.DoModal();
}

// *****************************************************************************

BOOL CConstantRateCtrl::Send(long data, long size) 
{
   if (!initflag) { initflag=1; puffer.SetBufferSize((unsigned int)m_bufferSize); }

   char *p=puffer.QueryFree((unsigned int)size); if (!p) return FALSE;
   memcpy(p, (void*)data, size);
   puffer.Brought((unsigned int)size);
   if (m_Port<0) OnReceive(p, (unsigned int)size);
   return TRUE;
}

short CConstantRateCtrl::GetBufferFilled() 
{
	return puffer.GetFillLevel();
}

void CConstantRateCtrl::OnBufferSizeChanged() 
{
	initflag=1;
   puffer.SetBufferSize((unsigned int)m_bufferSize);
	SetModifiedFlag();
}

void CConstantRateCtrl::OnDataRateChanged() 
{
	ChangeRate((UINT)m_dataRate);
	SetModifiedFlag();
}

void CConstantRateCtrl::OnBlockSizeChanged() 
{
   ChangeBlockSz((UINT)m_blockSize); 
	SetModifiedFlag();
}

void CConstantRateCtrl::OnSendingChanged() 
{
	if (m_sending) 
   {
      if (status==1) return;
      if (m_receiving) { ThrowError(CUSTOM_CTL_SCODE(ERRORNR_CSTRATE_BOTH), ERRORSTR_CSTRATE_BOTH, 0); m_sending=FALSE; return; }
	   ChangeRate((UINT)m_dataRate);
      ChangeBlockSz((UINT)m_blockSize); 
      if (m_Port>=0)
      {
         type=m_type?SOCK_STREAM:SOCK_DGRAM;
         if (!Connect((char*)(LPCTSTR)m_Host, m_Port)) { CString err; err.Format(" (error=%d)",GetLastError()); ThrowError(CUSTOM_CTL_SCODE(ERRORNR_CSTRATE_CONNECT), ERRORSTR_CSTRATE_CONNECT+err); m_sending=FALSE; return; }
         if (!StartCRSend()) ThrowError(CUSTOM_CTL_SCODE(ERRORNR_CSTRATE_STARTSEND), ERRORSTR_CSTRATE_STARTSEND,0);
         status=1;
      }
   }
   else 
   {
      if (status!=1) return;
      StopCRSend();
      Close();
      status=0;
   }
	SetModifiedFlag();
}

void CConstantRateCtrl::OnHostChanged() 
{
	if (m_sending) 
   {
	   m_sending=FALSE; OnSendingChanged();
	   m_sending=TRUE; OnSendingChanged();
   }
	SetModifiedFlag();
}

void CConstantRateCtrl::OnPortChanged() 
{
	if (m_sending) 
   {
	   m_sending=FALSE; OnSendingChanged();
	   m_sending=TRUE; OnSendingChanged();
   }
	if (m_receiving) 
   {
	   m_receiving=FALSE; OnReceivingChanged();
	   m_receiving=TRUE; OnReceivingChanged();
   }
   SetModifiedFlag();
}

void CConstantRateCtrl::OnReceive(char *adr, int size)
{
   if (!size) return;
   // wir sind im Thread, daher geht nicht: FireReceive((long)adr, size);
   tmp_adr=adr; tmp_size=size;
   if (hwndTarget) ::SendMessage(hwndTarget,WM_THREADFIREEVENT,0,0); 
}

void CConstantRateCtrl::OnOverflow(void)
{
   FireOverflow();
}

void CConstantRateCtrl::OnReceivingChanged() 
{
	if (m_receiving)
   {
      if (status==2) return;
      if (m_sending) { ThrowError(CUSTOM_CTL_SCODE(ERRORNR_CSTRATE_BOTH), ERRORSTR_CSTRATE_BOTH, 0); m_receiving=FALSE; return; }
      if (!initflag) { initflag=1;  puffer.SetBufferSize((unsigned int)m_bufferSize); }
      type=m_type?SOCK_STREAM:SOCK_DGRAM;
      if (!Bind((u_short)m_Port)) { CString err; err.Format(" (error=%d)",GetLastError()); ThrowError(CUSTOM_CTL_SCODE(ERRORNR_CSTRATE_BIND), ERRORSTR_CSTRATE_BIND+err, 0); m_receiving=FALSE; return; }
      mywnd=new CConstantRateWindow(this);
      hwndTarget=mywnd->Create();
      if (!StartReceive()) { ThrowError(CUSTOM_CTL_SCODE(ERRORNR_CSTRATE_STARTRECEIVE), ERRORNR_CSTRATE_STARTRECEIVE, 0); m_receiving=FALSE; mywnd->DestroyWindow(); delete mywnd; hwndTarget=0; return; }
      status=2;
   }
   else 
   {
      if (status!=2) return;
      StopReceive();
      mywnd->DestroyWindow(); delete mywnd; hwndTarget=0;
      if (type==SOCK_STREAM) client.Close();
      Close();
      status=0;
   }
	SetModifiedFlag();
}

void CConstantRateCtrl::Taken(long size) 
{
   puffer.Taken(size);
}

void CConstantRateCtrl::OnTypeChanged() 
{
	OnPortChanged();
}

long CConstantRateCtrl::Data1() 
{
   return (long)(puffer.GetData1());
}

long CConstantRateCtrl::Data2() 
{
   return (long)(puffer.GetData2());
}

long CConstantRateCtrl::Size1() 
{
   return puffer.GetSize1();
}

long CConstantRateCtrl::Size2() 
{
   return puffer.GetSize2();
}

BSTR CConstantRateCtrl::GetPeerName() 
{
   CString strResult;
   if (peername)
   {
      hostent *hent=gethostbyaddr(peername, 4, AF_INET);
	   strResult=hent->h_name;
      strResult.TrimRight();
   }
	return strResult.AllocSysString();
}

void CConstantRateCtrl::OnDisconnect(void)
{
   m_sending=FALSE; OnSendingChanged();
   FireDisconnect();
}

void CConstantRateCtrl::MessageBox(LPCTSTR txt, short flag, LPCTSTR caption) 
{
   ::MessageBox(0, txt, caption, flag);
}

void CConstantRateCtrl::ClearBuffer() 
{
   puffer.Clear();
}
