
#include "stdafx.h"
#include "video.h"
#include "VideoCaptureCtl.h"
   
#include <vfw.h>

#define ERRORNR_CAPTURE_HANDLE 1101
#define ERRORSTR_CAPTURE_HANDLE "Capture Not Active"
#define ERRORNR_CAPTURE_CONNECT 1102
#define ERRORSTR_CAPTURE_CONNECT "Unable to Connect Capture Driver"
#define ERRORNR_CAPTURE_DIALOG 1103
#define ERRORSTR_CAPTURE_DIALOG "Dialog Not Available"

extern CVideoApp NEAR theApp;
extern long bmpsize(BITMAPINFOHEADER* bmph);
extern long bmphsize(BITMAPINFOHEADER* bmph);
CString fourchar(unsigned long l);

CVideoCaptureCtrl *first=0, *last=0;

// typedef struct videohdr_tag {
//     LPBYTE      lpData;                 /* pointer to locked data buffer */
//     DWORD       dwBufferLength;         /* Length of data buffer */
//     DWORD       dwBytesUsed;            /* Bytes actually used */
//     DWORD       dwTimeCaptured;         /* Milliseconds from start of stream */
//     DWORD       dwUser;                 /* for client's use */
//     DWORD       dwFlags;                /* assorted flags (see defines) */
//     DWORD       dwReserved[4];          /* reserved for driver */
// } VIDEOHDR, NEAR *PVIDEOHDR, FAR * LPVIDEOHDR;
//
// /* dwFlags field of VIDEOHDR */
// #define VHDR_DONE       0x00000001  /* Done bit */
// #define VHDR_PREPARED   0x00000002  /* Set if this header has been prepared */
// #define VHDR_INQUEUE    0x00000004  /* Reserved for driver */
// #define VHDR_KEYFRAME   0x00000008  /* Key Frame */
LRESULT FAR PASCAL FrameCallbackProc(HWND hWnd, LPVIDEOHDR lpVHdr)
{
   for (CVideoCaptureCtrl *v=first; v; v=v->next)
      if (v->hWnd==hWnd) { v->FrameCallbackProc((long)(lpVHdr->lpData), (long)(lpVHdr->dwBytesUsed)); break; }
   return (LRESULT) TRUE ; 
} 

IMPLEMENT_DYNCREATE(CVideoCaptureCtrl, COleControl)

BEGIN_MESSAGE_MAP(CVideoCaptureCtrl, COleControl)
	//{{AFX_MSG_MAP(CVideoCaptureCtrl)
	//}}AFX_MSG_MAP
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CVideoCaptureCtrl, COleControl)
	//{{AFX_DISPATCH_MAP(CVideoCaptureCtrl)
	DISP_PROPERTY(CVideoCaptureCtrl, "Compression", m_compression, VT_BSTR)
	DISP_PROPERTY(CVideoCaptureCtrl, "Colors", m_colors, VT_I4)
	DISP_PROPERTY_NOTIFY(CVideoCaptureCtrl, "DeviceNr", m_deviceNr, OnDeviceNrChanged, VT_I2)
	DISP_PROPERTY_NOTIFY(CVideoCaptureCtrl, "AutoSize", m_autoSize, OnAutoSizeChanged, VT_BOOL)
	DISP_PROPERTY_NOTIFY(CVideoCaptureCtrl, "Stretch", m_stretch, OnStretchChanged, VT_BOOL)
	DISP_PROPERTY_NOTIFY(CVideoCaptureCtrl, "PreviewRate", m_previewRate, OnPreviewRateChanged, VT_I4)
	DISP_PROPERTY_NOTIFY(CVideoCaptureCtrl, "Capture", m_capture, OnCaptureChanged, VT_BOOL)
	DISP_PROPERTY_EX(CVideoCaptureCtrl, "CaptureWidth", GetCaptureWidth, SetNotSupported, VT_I4)
	DISP_PROPERTY_EX(CVideoCaptureCtrl, "CaptureHeight", GetCaptureHeight, SetNotSupported, VT_I4)
	DISP_PROPERTY_EX(CVideoCaptureCtrl, "DlgFormatQuery", GetDlgFormatQuery, SetNotSupported, VT_BOOL)
	DISP_PROPERTY_EX(CVideoCaptureCtrl, "DlgSourceQuery", GetDlgSourceQuery, SetNotSupported, VT_BOOL)
	DISP_PROPERTY_EX(CVideoCaptureCtrl, "DlgDisplayQuery", GetDlgDisplayQuery, SetNotSupported, VT_BOOL)
	DISP_FUNCTION(CVideoCaptureCtrl, "DlgFormat", DlgFormat, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CVideoCaptureCtrl, "DlgSource", DlgSource, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CVideoCaptureCtrl, "DlgCompression", DlgCompression, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CVideoCaptureCtrl, "DlgDisplay", DlgDisplay, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CVideoCaptureCtrl, "PlayAvi", PlayAvi, VT_EMPTY, VTS_BSTR)
	DISP_FUNCTION(CVideoCaptureCtrl, "CaptureSingleFrame", CaptureSingleFrame, VT_EMPTY, VTS_BSTR)
	DISP_FUNCTION(CVideoCaptureCtrl, "CaptureSequenceStart", CaptureSequenceStart, VT_EMPTY, VTS_BSTR)
	DISP_FUNCTION(CVideoCaptureCtrl, "CaptureSequenceStop", CaptureSequenceStop, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CVideoCaptureCtrl, "StopAvi", StopAvi, VT_EMPTY, VTS_NONE)
	DISP_PROPERTY_PARAM(CVideoCaptureCtrl, "DeviceName", GetDeviceName, SetNotSupported, VT_BSTR, VTS_I2)
	DISP_STOCKPROP_BACKCOLOR()
	DISP_PROPERTY_EX_ID(CVideoCaptureCtrl, "hWnd", DISPID_HWND, GetHWnd, SetNotSupported, VT_HANDLE)
	//}}AFX_DISPATCH_MAP
	DISP_FUNCTION_ID(CVideoCaptureCtrl, "AboutBox", DISPID_ABOUTBOX, AboutBox, VT_EMPTY, VTS_NONE)
END_DISPATCH_MAP()

BEGIN_EVENT_MAP(CVideoCaptureCtrl, COleControl)
	//{{AFX_EVENT_MAP(CVideoCaptureCtrl)
	EVENT_CUSTOM("OnFrame", FireOnFrame, VTS_I4  VTS_I4  VTS_I4)
	EVENT_CUSTOM("Resize", FireResize, VTS_I4  VTS_I4)
	//}}AFX_EVENT_MAP
END_EVENT_MAP()

IMPLEMENT_OLECREATE_EX(CVideoCaptureCtrl, "VIDEO.VideoCaptureCtrl.1", 0x96872fa3, 0xd44c, 0x11d1, 0xa8, 0x98, 0, 0x20, 0xaf, 0xf8, 0x4c, 0xb3)
IMPLEMENT_OLETYPELIB(CVideoCaptureCtrl, _tlid, _wVerMajor, _wVerMinor)

const IID BASED_CODE IID_DVideoCapture = { 0x96872fa1, 0xd44c, 0x11d1, { 0xa8, 0x98, 0, 0x20, 0xaf, 0xf8, 0x4c, 0xb3 } };
const IID BASED_CODE IID_DVideoCaptureEvents = { 0x96872fa2, 0xd44c, 0x11d1, { 0xa8, 0x98, 0, 0x20, 0xaf, 0xf8, 0x4c, 0xb3 } };

static const DWORD BASED_CODE _dwVideoCaptureOleMisc =
	OLEMISC_ACTIVATEWHENVISIBLE |
   OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CVideoCaptureCtrl, IDS_VIDEOCAPTURE, _dwVideoCaptureOleMisc)

BOOL CVideoCaptureCtrl::CVideoCaptureCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_VIDEOCAPTURE,
			IDB_VIDEOCAPTURE,
			afxRegApartmentThreading,
			_dwVideoCaptureOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}

CVideoCaptureCtrl::CVideoCaptureCtrl()
{
	InitializeIIDs(&IID_DVideoCapture, &IID_DVideoCaptureEvents);
   m_width=-1; m_height=-1;
   OnResetState();
   status=0;
   playavi=0;
   prev=last; (last?last->next:first)=this; last=this; next=0;
}

CVideoCaptureCtrl::~CVideoCaptureCtrl()
{
	if (m_capture) { m_capture=FALSE; OnCaptureChanged(); }
   if (playavi) StopAvi();
   (prev?prev->next:first)=next; (next?next->prev:last)=prev;
}

void CVideoCaptureCtrl::OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
   if (!AmbientUserMode()) { DrawOcxBitmap(this, pdc, rcBounds, IDB_VIDEOCAPTURE); return; }
   CBrush cb; cb.CreateSolidBrush(TranslateColor(GetBackColor())); pdc->FillRect(rcBounds, &cb);
}

void CVideoCaptureCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);

   PX_Bool(pPX, "AutoSize", m_autoSize, TRUE);
   PX_Bool(pPX, "Stretch", m_stretch, FALSE);
   PX_Short(pPX, "DeviceNr", m_deviceNr, 0);
   PX_Long(pPX, "PreviewRate", m_previewRate, 1);
}

void CVideoCaptureCtrl::OnResetState()
{
	COleControl::OnResetState();  // Resets defaults found in DoPropExchange

   if (playavi) StopAvi();
   playavi=0;
   m_capture=0;
   m_compression="";
   m_colors=0;
   hWnd=0;
   blocked=0;
}

void CVideoCaptureCtrl::AboutBox()
{
	CDialog dlgAbout(IDD_ABOUTBOX);
	dlgAbout.DoModal();
}

// **********************************************************************

long CVideoCaptureCtrl::GetCaptureWidth() 
{
   // BITMAPINFOHEADER bmph; capGetVideoFormat(hWnd, &bmph, sizeof(BITMAPINFOHEADER)); return bmph.biWidth; 
   if (!hWnd) return 0;
   CAPSTATUS s;
   capGetStatus(hWnd, &s, sizeof(CAPSTATUS));
   return s.uiImageWidth;
}

long CVideoCaptureCtrl::GetCaptureHeight() 
{
   if (!hWnd) return 0;
   CAPSTATUS s;
   capGetStatus(hWnd, &s, sizeof(CAPSTATUS));
   return s.uiImageHeight;
}

void CVideoCaptureCtrl::OnCaptureChanged() 
{
   if (status==m_capture) return;
   if (m_capture)
   {
      if (playavi) StopAvi();
      hWnd=capCreateCaptureWindow("", WS_CHILD /*CAPTION|WS_THICKFRAME|WS_SYSMENU*/, 0, 0, 360, 270, m_hWnd, 0);

      if (!capDriverConnect(hWnd, m_deviceNr)) { m_capture=FALSE; ::SendMessage(hWnd, WM_CLOSE, 0, 0L); hWnd=0; ThrowError(CUSTOM_CTL_SCODE(ERRORNR_CAPTURE_CONNECT), ERRORSTR_CAPTURE_CONNECT, 0); return; }

      capSetCallbackOnFrame(hWnd, ::FrameCallbackProc); 
      capPreviewScale(hWnd, TRUE); 

      CAPSTATUS s;
      capGetStatus(hWnd, &s, sizeof(CAPSTATUS));

      int x, y;
      if (m_autoSize) SetControlSize(s.uiImageWidth, s.uiImageHeight);
      if (m_stretch) GetControlSize(&x, &y); else { x=s.uiImageWidth; y=s.uiImageHeight; }
      ::MoveWindow(hWnd, 0, 0, x, y, TRUE);
      ::ShowWindow(hWnd, SW_SHOW);
            
      capPreviewRate(hWnd, m_previewRate);  // rate, in milliseconds
      capPreview(hWnd, m_previewRate?TRUE:FALSE);

      FireResize(s.uiImageWidth, s.uiImageHeight);
   }
   else
   {
      capDriverDisconnect(hWnd); ::SendMessage(hWnd, WM_CLOSE, 0, 0L);
      hWnd=0;
   }
	SetModifiedFlag();
   status=m_capture;
}

void CVideoCaptureCtrl::OnDeviceNrChanged() 
{
   if (m_capture)
   {
      m_capture=FALSE; OnCaptureChanged();
      m_capture=TRUE; OnCaptureChanged();
   }
   SetModifiedFlag(); 
}

void CVideoCaptureCtrl::FrameCallbackProc(long data, long size)
{
   if (!AmbientUserMode() || blocked) return;

   int x, y;
   GetControlSize(&x, &y);
   if (m_width!=x || m_height!=y)
   {
      m_width=x; m_height=y;
      CAPSTATUS s; capGetStatus(hWnd, &s, sizeof(CAPSTATUS));
      if (m_autoSize) SetControlSize(s.uiImageWidth, s.uiImageHeight);
      if (m_stretch) GetControlSize(&x, &y); else { x=s.uiImageWidth; y=s.uiImageHeight; }
      ::MoveWindow(hWnd, 0, 0, x, y, TRUE);
      ::ShowWindow(hWnd, SW_SHOW);
   }

   int z=capGetVideoFormat(hWnd, 0, 0);
   char *b=new char[z];
   capGetVideoFormat(hWnd, b, z); 
   BITMAPINFO *bh=(BITMAPINFO *)b;

   m_compression=fourchar(bh->bmiHeader.biCompression);
   m_colors=bh->bmiHeader.biBitCount;
   blocked=1;
   FireOnFrame((long)b, data, size);
   blocked=0;

   delete b;
}

void CVideoCaptureCtrl::DlgFormat() 
{
   if (!hWnd) { ThrowError(CUSTOM_CTL_SCODE(ERRORNR_CAPTURE_HANDLE), ERRORSTR_CAPTURE_HANDLE, 0); return; }
   if (!GetDlgFormatQuery()) { ThrowError(CUSTOM_CTL_SCODE(ERRORNR_CAPTURE_DIALOG), ERRORSTR_CAPTURE_DIALOG, 0); return; }

   capDlgVideoFormat(hWnd); 

   // BITMAPINFOHEADER bmph;
   // capGetVideoFormat(hWnd, &bmph, sizeof(BITMAPINFOHEADER)); 
   // SetWindowPos(0, 0, 0, bmph.biWidth, bmph.biHeight, SWP_NOMOVE | SWP_NOOWNERZORDER | SWP_NOZORDER | SWP_SHOWWINDOW);
   // codec.encoder_set(&bmph_camera);  // bmph des encoder-Ausgangs berechnen
   // ausg.meldung("new sended size: "+str(bmph_camera.biWidth)+" "+str(bmph_camera.biHeight)+" -> "+str(codec.m_bmph->biWidth)+" "+str(codec.m_bmph->biHeight));

   CAPSTATUS s;
   capGetStatus(hWnd, &s, sizeof(CAPSTATUS));
   ::MoveWindow(hWnd, 0, 0, s.uiImageWidth, s.uiImageHeight, TRUE);
   if (m_autoSize) SetControlSize(s.uiImageWidth, s.uiImageHeight);
   FireResize(s.uiImageWidth, s.uiImageHeight);
}

void CVideoCaptureCtrl::DlgSource() 
{
   if (!hWnd) { ThrowError(CUSTOM_CTL_SCODE(ERRORNR_CAPTURE_HANDLE), ERRORSTR_CAPTURE_HANDLE, 0); return; }
   if (!GetDlgSourceQuery()) { ThrowError(CUSTOM_CTL_SCODE(ERRORNR_CAPTURE_DIALOG), ERRORSTR_CAPTURE_DIALOG, 0); return; }
   capDlgVideoSource(hWnd); 
}

void CVideoCaptureCtrl::DlgDisplay() 
{
   if (!hWnd) { ThrowError(CUSTOM_CTL_SCODE(ERRORNR_CAPTURE_HANDLE), ERRORSTR_CAPTURE_HANDLE, 0); return; }
   if (!GetDlgDisplayQuery()) { ThrowError(CUSTOM_CTL_SCODE(ERRORNR_CAPTURE_DIALOG), ERRORSTR_CAPTURE_DIALOG, 0); return; }
   capDlgVideoDisplay(hWnd); 
}

void CVideoCaptureCtrl::DlgCompression() 
{
   if (!hWnd) { ThrowError(CUSTOM_CTL_SCODE(ERRORNR_CAPTURE_HANDLE), ERRORSTR_CAPTURE_HANDLE, 0); return; }
   capDlgVideoCompression(hWnd);
}

BOOL CVideoCaptureCtrl::GetDlgFormatQuery() 
{
   if (!hWnd) return FALSE;
   CAPDRIVERCAPS s;
   capDriverGetCaps(hWnd, &s, sizeof(CAPDRIVERCAPS));
   return s.fHasDlgVideoFormat;
}

BOOL CVideoCaptureCtrl::GetDlgSourceQuery() 
{
   if (!hWnd) return FALSE;
   CAPDRIVERCAPS s; 
   capDriverGetCaps(hWnd, &s, sizeof(CAPDRIVERCAPS));
   return s.fHasDlgVideoSource;
}

BOOL CVideoCaptureCtrl::GetDlgDisplayQuery() 
{
   if (!hWnd) return FALSE;
   CAPDRIVERCAPS s; 
   capDriverGetCaps(hWnd, &s, sizeof(CAPDRIVERCAPS));
   return s.fHasDlgVideoDisplay;
}

BSTR CVideoCaptureCtrl::GetDeviceName(short nr) 
{
   char name[100], ver[50];
   name[0]=0;
   if (nr>=0 && nr<=9) capGetDriverDescription(nr, name, 100, ver, 50);
   CString s=name; // s+="  ["; s+=ver; s+="]";
	return s.AllocSysString();
}

void CVideoCaptureCtrl::OnAutoSizeChanged() 
{
   if (m_autoSize && hWnd)
   {
      CAPSTATUS s;
      capGetStatus(hWnd, &s, sizeof(CAPSTATUS));
      SetControlSize(s.uiImageWidth, s.uiImageHeight);
      ::MoveWindow(hWnd, 0, 0, s.uiImageWidth, s.uiImageHeight, TRUE);
      ::ShowWindow(hWnd, SW_SHOW);
   }
	SetModifiedFlag();
}

void CVideoCaptureCtrl::OnStretchChanged() 
{
   if (!m_autoSize && hWnd)
   {
      int x, y;
      if (m_stretch) GetControlSize(&x, &y); else { CAPSTATUS s; capGetStatus(hWnd, &s, sizeof(CAPSTATUS)); x=s.uiImageWidth; y=s.uiImageHeight; }
      ::MoveWindow(hWnd, 0, 0, x, y, TRUE);
      ::ShowWindow(hWnd, SW_SHOW);
   }
	SetModifiedFlag();
}

OLE_HANDLE CVideoCaptureCtrl::GetHWnd() 
{
	return (unsigned int)hWnd;
}

void CALLBACK EXPORT PlayAviTimer(HWND hWnd, UINT nMsg, UINT nIDEvent, DWORD dwTime)
{
   for (CVideoCaptureCtrl *v=first; v; v=v->next)
      if (v->m_hWnd==hWnd) { v->PlayAviTimer(); break; }
}

void CVideoCaptureCtrl::PlayAviTimer(void)
{
   if (!playavi || !IsWindow(m_hWnd) || blocked) return;

   PGETFRAME pgf=AVIStreamGetFrameOpen(playavi_pavi, NULL);
   long data=(long)AVIStreamGetFrame(pgf, playavi_lPos);
   if (!data) { StopAvi(); return; }

   BITMAPINFOHEADER *b=(BITMAPINFOHEADER*)data;
   data+=bmphsize(b);
   
   if (m_previewRate)
   {
      int x, y;
      if (m_stretch) GetControlSize(&x, &y); else { x=b->biWidth; y=b->biHeight; }

      CDC *dc=GetDC();
      HDRAWDIB hdd=DrawDibOpen();
      DrawDibDraw(hdd, dc->m_hDC, 0, 0, x, y, b, (void*)data, 0, 0, b->biWidth, b->biHeight, 0);
      DrawDibClose(hdd);
      ReleaseDC(dc);
   }

   m_compression=fourchar(b->biCompression);
   m_colors=b->biBitCount;
   blocked=1;
   FireOnFrame((long)b, data, bmpsize(b));
   blocked=0;

   AVIStreamGetFrameClose(pgf);

   playavi_lPos++;
}

void CVideoCaptureCtrl::PlayAvi(LPCTSTR Filename) 
{
   if (playavi) StopAvi();
   if (m_capture) { m_capture=FALSE; OnCaptureChanged(); }

	AVIFileInit();
   if (AVIFileOpen(&playavi_pfile, Filename, 0, 0L)) { AVIFileExit(); return; }
   if (AVIFileGetStream(playavi_pfile, &playavi_pavi, streamtypeVIDEO, 0)!=AVIERR_OK) { AVIFileRelease(playavi_pfile); AVIFileExit(); return; }
   playavi_lPos=AVIStreamStart(playavi_pavi);

   BYTE abFormat[1024]; long l=sizeof(abFormat);
   AVIStreamReadFormat(playavi_pavi, 0, &abFormat, &l);
   BITMAPINFOHEADER *b=(BITMAPINFOHEADER*)abFormat;
   if (m_autoSize) SetControlSize(b->biWidth, b->biHeight);
   m_width=b->biWidth; m_height=b->biHeight;

   AVISTREAMINFO aviinfo;
   AVIStreamInfo(playavi_pavi, &aviinfo, sizeof(aviinfo));
   UINT millisec=(UINT)(1000.0*aviinfo.dwScale/aviinfo. dwRate); // =1000/fps; fps=dwRate/dwScale;
   if (SetTimer(1, millisec, ::PlayAviTimer)) playavi=1;
}

void CVideoCaptureCtrl::StopAvi() 
{
   if (!playavi) return;
   KillTimer(1);
   AVIFileRelease(playavi_pfile);
   AVIFileExit();
   playavi=0;
}

void CVideoCaptureCtrl::CaptureSingleFrame(LPCTSTR Filename) 
{
	if (!hWnd) return;
   capFileSetCaptureFile(hWnd, (char*)Filename);
   capCaptureSingleFrameOpen(hWnd);
   capCaptureSingleFrame(hWnd);
   capCaptureSingleFrameClose(hWnd);
}

void CVideoCaptureCtrl::CaptureSequenceStart(LPCTSTR Filename) 
{
	if (!hWnd) return;
   capFileSetCaptureFile(hWnd, (char*)Filename);
   capCaptureSequence(hWnd);
}

void CVideoCaptureCtrl::CaptureSequenceStop() 
{
	if (!hWnd) return;
   capCaptureStop(hWnd);
}

void CVideoCaptureCtrl::OnPreviewRateChanged() 
{
   if (hWnd) 
   {
      capPreviewRate(hWnd, m_previewRate);  // rate, in milliseconds
      capPreview(hWnd, m_previewRate?TRUE:FALSE);
   }
	SetModifiedFlag();
}

